import { memo as _$memo, createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import { For } from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { useTsp } from "@typespec/emitter-framework";
import * as ef from "@typespec/emitter-framework/typescript";
import { useClientLibrary } from "@typespec/http-client";
export function Models(props) {
  const {
    $
  } = useTsp();
  const clientLibrary = useClientLibrary();
  const dataTypes = clientLibrary.dataTypes;
  return _$createComponent(ts.SourceFile, {
    get path() {
      return props.path ?? "models.ts";
    },
    get children() {
      return _$createComponent(For, {
        each: dataTypes,
        hardline: true,
        children: type => {
          return $.array.is(type) || $.record.is(type) ? null : _$createComponent(ef.TypeDeclaration, {
            "export": true,
            type: type,
            get refkey() {
              return ay.refkey(type);
            }
          });
        }
      });
    }
  });
}