import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import * as ef from "@typespec/emitter-framework/typescript";
export function getPageResponseTypeRefkey(operation) {
  return ay.refkey(operation, "page-response");
}
export function PageResponseDeclaration(props) {
  const namePolicy = ts.useTSNamePolicy();
  const interfaceName = namePolicy.getName(props.operation.operation.name + "PageResponse", "interface");
  const definedResponses = props.pagingOperation.output;
  // Only accept these respose items
  const acceptedColumns = ["continuationToken", "pageItems", "nextLink", "prevLink", "firstLink", "lastLink"];
  const responseProperties = [];
  for (const key in definedResponses) {
    const property = definedResponses[key];
    if (acceptedColumns.includes(key) && !!property) {
      responseProperties.push(property);
    }
  }
  return _$createComponent(ts.InterfaceDeclaration, {
    "export": true,
    name: interfaceName,
    get refkey() {
      return getPageResponseTypeRefkey(props.operation);
    },
    get children() {
      return _$createComponent(ay.For, {
        each: responseProperties,
        line: true,
        children: parameter => _$createComponent(ts.InterfaceMember, {
          get name() {
            return parameter.property.name;
          },
          get optional() {
            return parameter.property.optional;
          },
          get type() {
            return _$createComponent(ef.TypeExpression, {
              get type() {
                return parameter.property.type;
              }
            });
          }
        })
      });
    }
  });
}