import { memo as _$memo, createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
export function getFileContentsTypeReference() {
  return ay.refkey("FileContents", "type", "static-helpers");
}
export function getCreateFilePartDescriptorReference() {
  return ay.refkey("createFilePartDescriptor", "function", "static-helpers");
}
export function getFileTypeReference() {
  return ay.refkey("File", "type", "static-helpers");
}
export function MultipartHelpers(props) {
  return _$createComponent(ts.SourceFile, {
    path: "multipart-helpers.ts",
    get children() {
      return [_$createComponent(ts.InterfaceDeclaration, {
        name: "File",
        "export": true,
        get refkey() {
          return getFileTypeReference();
        },
        get children() {
          return ["contents: ", _$memo(() => getFileContentsTypeReference()), "; contentType?: string; filename?: string;"];
        }
      }), _$createComponent(ts.TypeDeclaration, {
        name: "FileContents",
        "export": true,
        kind: "type",
        get refkey() {
          return getFileContentsTypeReference();
        },
        get children() {
          return ay.mapJoin(() => ["string", "NodeJS.ReadableStream", "ReadableStream<Uint8Array>", "Uint8Array", "Blob"], t => t, {
            joiner: " | "
          });
        }
      }), _$createComponent(ts.FunctionDeclaration, {
        name: "createFilePartDescriptor",
        get parameters() {
          return getCreateFilePartParameters();
        },
        "export": true,
        returnType: "any",
        get refkey() {
          return getCreateFilePartDescriptorReference();
        },
        get children() {
          return ay.code`
       if (fileInput.contents) {
          return {
            name: partName,
            body: fileInput.contents,
            contentType: fileInput.contentType ?? defaultContentType,
            filename: fileInput.filename,
          };
        } else {
          return {
            name: partName,
            body: fileInput,
            contentType: defaultContentType,
          };
        }
      `;
        }
      })];
    }
  });
}
function getCreateFilePartParameters() {
  return [{
    name: "partName",
    type: "string"
  }, {
    name: "fileInput",
    type: "any"
  }, {
    name: "defaultContentType",
    optional: true,
    refkey: ay.refkey(),
    type: "string"
  }];
}