import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { getCreateFilePartDescriptorReference } from "../../static-helpers/multipart-helpers.js";
export function FilePartTransform(props) {
  const namePolicy = ts.useTSNamePolicy();
  const defaultContentType = getContentType(props.part);
  const applicationName = namePolicy.getName(props.part.name, "variable");
  const itemRef = getPartRef(props.itemRef, applicationName);
  const args = [JSON.stringify(props.part.name), itemRef];
  if (defaultContentType) {
    args.push(ts.ValueExpression({
      jsValue: defaultContentType
    }));
  }
  return _$createComponent(ts.FunctionCallExpression, {
    get target() {
      return getCreateFilePartDescriptorReference();
    },
    args: args
  });
}
function getContentType(part) {
  const contentTypes = part.body.contentTypes;
  if (contentTypes.length !== 1) {
    return undefined;
  }
  const contentType = contentTypes[0];
  if (!contentType || contentType === "*/*") {
    return undefined;
  }
  return contentType;
}
function getPartRef(itemRef, partName) {
  if (itemRef === null) {
    return partName;
  }
  return ay.code`${itemRef}.${partName}`;
}