import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import { ArrayPartTransform } from "./array-part-transform.js";
import { FilePartTransform } from "./file-part-transform.js";
import { SimplePartTransform } from "./simple-part-transform.js";
export function HttpPartTransform(props) {
  if (props.part.multi) {
    return _$createComponent(ArrayPartTransform, {
      get part() {
        return props.part;
      },
      get itemRef() {
        return props.itemRef;
      }
    });
  }
  if (props.part.filename) {
    return _$createComponent(FilePartTransform, {
      get part() {
        return props.part;
      },
      get itemRef() {
        return props.itemRef;
      }
    });
  }
  return _$createComponent(SimplePartTransform, {
    get part() {
      return props.part;
    },
    get itemRef() {
      return props.itemRef;
    }
  });
}